//---------------------------------------------------------------------------
//
//  SCSI Target Emulator RaSCSI (*^..^*)
//  for Raspberry Pi
//
//  Powered by XM6 TypeG Technorogy.
//  Copyright (C) 2016-2017 GIMONS
//	[ zXgt@CVXe ubWhCo ]
//
//---------------------------------------------------------------------------

#include <stdio.h>
#include <string.h>
#include <sys/dos.h>
#include <sys/scsi.h>
#include <iocslib.h>
#include "bridge.h"

//---------------------------------------------------------------------------
//
//  ϐ錾
//
//---------------------------------------------------------------------------
volatile BYTE *request;				// NGXgwb_AhX
DWORD command;						// R}hԍ
DWORD unit;							// jbgԍ

//===========================================================================
//
/// t@CVXe(SCSIAg)
//
//===========================================================================
typedef struct
{
	char DeviceType;
	char RMB;
	char ANSI_Ver;
	char RDF;
	char AddLen;
	char RESV0;
	char RESV1;
	char OptFunc;
	char VendorID[8];
	char ProductID[16];
	char FirmRev[4];
} INQUIRY_T;

int scsiid;	// SCSI ID

//---------------------------------------------------------------------------
//
// 
//
//---------------------------------------------------------------------------
BOOL SCSI_Init(void)
{
	int i;
	INQUIRY_T inq;

	// SCSI ID
	scsiid = -1;
	
	for (i = 0; i <= 7; i++) {
		if (S_INQUIRY(sizeof(INQUIRY_T) , i, (struct INQUIRY*)&inq) < 0) {
			continue;
		}

		if (memcmp(&(inq.ProductID), "RASCSI BRIDGE", 13) != 0) {
			continue;
		}

		// SCSI IDm
		scsiid = i;
		return TRUE;
	}

	return FALSE;
}

//---------------------------------------------------------------------------
//
// R}hM
//
//---------------------------------------------------------------------------
int SCSI_SendCmd(BYTE *buf, int len)
{
	int ret;
	BYTE cmdbuf[10];
	BYTE sts;
	BYTE msg;
	BYTE retbuf[4];
	
	ret = FS_FATAL_MEDIAOFFLINE;

	cmdbuf[0] = 0x2a;
	cmdbuf[1] = 0;
	cmdbuf[2] = 2;
	cmdbuf[3] = command;
	cmdbuf[4] = 0;
	cmdbuf[5] = 0;
	cmdbuf[6] = (BYTE)(len >> 16);
	cmdbuf[7] = (BYTE)(len >> 8);
	cmdbuf[8] = (BYTE)len;
	cmdbuf[9] = 0;

	// ZNg^CAEg鎞ɂ͍Ďs
	if (S_SELECT(scsiid) != 0) {
		S_RESET();
		if (S_SELECT(scsiid) != 0) {
			return ret;
		}
	}

	if (S_CMDOUT(10, cmdbuf) != 0) {
		return ret;
	}

	if (S_DATAOUT_P(len, buf) != 0) {
		return ret;
	}

	if (S_STSIN(&sts) != 0) {
		return ret;
	}

	if (S_MSGIN(&msg) != 0) {
		return ret;
	}

	cmdbuf[0] = 0x28;
	cmdbuf[1] = 0;
	cmdbuf[2] = 2;
	cmdbuf[3] = command;
	cmdbuf[4] = 0;
	cmdbuf[5] = 0;
	cmdbuf[6] = 0;
	cmdbuf[7] = 0;
	cmdbuf[8] = 4;
	cmdbuf[9] = 0;

	// ZNg^CAEg鎞ɂ͍Ďs
	if (S_SELECT(scsiid) != 0) {
		S_RESET();
		if (S_SELECT(scsiid) != 0) {
			return ret;
		}
	}

	if (S_CMDOUT(10, cmdbuf) != 0) {
		return ret;
	}

	if (S_DATAIN_P(4, retbuf) != 0) {
		return ret;
	}

	if (S_STSIN(&sts) != 0) {
		return ret;
	}

	if (S_MSGIN(&msg) != 0) {
		return ret;
	}
	
	ret = *(int*)retbuf;
	return ret;
}

//---------------------------------------------------------------------------
//
// R}hĂяo
//
//---------------------------------------------------------------------------
int SCSI_CalCmd(BYTE *buf, int len, BYTE *outbuf, int outlen)
{
	int ret;
	BYTE cmdbuf[10];
	BYTE sts;
	BYTE msg;
	BYTE retbuf[4];
	
	ret = FS_FATAL_MEDIAOFFLINE;

	cmdbuf[0] = 0x2a;
	cmdbuf[1] = 0;
	cmdbuf[2] = 2;
	cmdbuf[3] = command;
	cmdbuf[4] = 0;
	cmdbuf[5] = 0;
	cmdbuf[6] = (BYTE)(len >> 16);
	cmdbuf[7] = (BYTE)(len >> 8);
	cmdbuf[8] = (BYTE)len;
	cmdbuf[9] = 0;
	
	// ZNg^CAEg鎞ɂ͍Ďs
	if (S_SELECT(scsiid) != 0) {
		S_RESET();
		if (S_SELECT(scsiid) != 0) {
			return ret;
		}
	}

	if (S_CMDOUT(10, cmdbuf) != 0) {
		return ret;
	}

	if (S_DATAOUT_P(len, buf) != 0) {
		return ret;
	}

	if (S_STSIN(&sts) != 0) {
		return ret;
	}

	if (S_MSGIN(&msg) != 0) {
		return ret;
	}

	cmdbuf[0] = 0x28;
	cmdbuf[1] = 0;
	cmdbuf[2] = 2;
	cmdbuf[3] = command;
	cmdbuf[4] = 0;
	cmdbuf[5] = 0;
	cmdbuf[6] = 0;
	cmdbuf[7] = 0;
	cmdbuf[8] = 4;
	cmdbuf[9] = 0;

	// ZNg^CAEg鎞ɂ͍Ďs
	if (S_SELECT(scsiid) != 0) {
		S_RESET();
		if (S_SELECT(scsiid) != 0) {
			return ret;
		}
	}

	if (S_CMDOUT(10, cmdbuf) != 0) {
		return ret;
	}

	if (S_DATAIN_P(4, retbuf) != 0) {
		return ret;
	}

	if (S_STSIN(&sts) != 0) {
		return ret;
	}

	if (S_MSGIN(&msg) != 0) {
		return ret;
	}

	// G[Ȃԋpf[^̎M~߂
	ret = *(int*)retbuf;
	if (ret < 0) {
		return ret;
	}

	cmdbuf[0] = 0x28;
	cmdbuf[1] = 0;
	cmdbuf[2] = 2;
	cmdbuf[3] = command;
	cmdbuf[4] = 0;
	cmdbuf[5] = 0;
	cmdbuf[6] = (BYTE)(outlen >> 16);
	cmdbuf[7] = (BYTE)(outlen >> 8);
	cmdbuf[8] = (BYTE)outlen;
	cmdbuf[9] = 1;

	// ZNg^CAEg鎞ɂ͍Ďs
	if (S_SELECT(scsiid) != 0) {
		S_RESET();
		if (S_SELECT(scsiid) != 0) {
			return ret;
		}
	}

	if (S_CMDOUT(10, cmdbuf) != 0) {
		return ret;
	}

	if (S_DATAIN_P(outlen, outbuf) != 0) {
		return ret;
	}

	if (S_STSIN(&sts) != 0) {
		return ret;
	}

	if (S_MSGIN(&msg) != 0) {
		return ret;
	}
	
	ret = *(int*)retbuf;
	return ret;
}

//---------------------------------------------------------------------------
//
// IvVf[^擾
//
//---------------------------------------------------------------------------
BOOL SCSI_ReadOpt(BYTE *buf, int len)
{
	BYTE cmdbuf[10];
	BYTE sts;
	BYTE msg;

	cmdbuf[0] = 0x28;
	cmdbuf[1] = 0;
	cmdbuf[2] = 2;
	cmdbuf[3] = command;
	cmdbuf[4] = 0;
	cmdbuf[5] = 0;
	cmdbuf[6] = (BYTE)(len >> 16);
	cmdbuf[7] = (BYTE)(len >> 8);
	cmdbuf[8] = (BYTE)len;
	cmdbuf[9] = 2;

	// ZNg^CAEg鎞ɂ͍Ďs
	if (S_SELECT(scsiid) != 0) {
		S_RESET();
		if (S_SELECT(scsiid) != 0) {
			return FALSE;
		}
	}

	if (S_CMDOUT(10, cmdbuf) != 0) {
		return FALSE;
	}

	if (S_DATAIN_P(len, buf) != 0) {
		return FALSE;
	}

	if (S_STSIN(&sts) != 0) {
		return FALSE;
	}

	if (S_MSGIN(&msg) != 0) {
		return FALSE;
	}
	
	return TRUE;
}

//---------------------------------------------------------------------------
//
// IvVf[^
//
//---------------------------------------------------------------------------
BOOL SCSI_WriteOpt(BYTE *buf, int len)
{
	BYTE cmdbuf[10];
	BYTE sts;
	BYTE msg;

	cmdbuf[0] = 0x2a;
	cmdbuf[1] = 0;
	cmdbuf[2] = 2;
	cmdbuf[3] = command;
	cmdbuf[4] = 0;
	cmdbuf[5] = 0;
	cmdbuf[6] = (BYTE)(len >> 16);
	cmdbuf[7] = (BYTE)(len >> 8);
	cmdbuf[8] = (BYTE)len;
	cmdbuf[9] = 1;

	// ZNg^CAEg鎞ɂ͍Ďs
	if (S_SELECT(scsiid) != 0) {
		S_RESET();
		if (S_SELECT(scsiid) != 0) {
			return FALSE;
		}
	}

	if (S_CMDOUT(10, cmdbuf) != 0) {
		return FALSE;
	}

	if (S_DATAOUT_P(len, buf) != 0) {
		return FALSE;
	}

	if (S_STSIN(&sts) != 0) {
		return FALSE;
	}

	if (S_MSGIN(&msg) != 0) {
		return FALSE;
	}

	return TRUE;
}

//===========================================================================
//
/// t@CVXe
//
//===========================================================================

//---------------------------------------------------------------------------
//
//  $40 - foCXN
//
//---------------------------------------------------------------------------
DWORD FS_InitDevice(const argument_t* pArgument)
{
	return (DWORD)SCSI_SendCmd((BYTE*)pArgument, sizeof(argument_t));
}

//---------------------------------------------------------------------------
//
//  $41 - fBNg`FbN
//
//---------------------------------------------------------------------------
int FS_CheckDir(const namests_t* pNamests)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	memcpy(&buf[i], pNamests, sizeof(namests_t));
	i += sizeof(namests_t);
	
	return SCSI_SendCmd(buf, i);
}

//---------------------------------------------------------------------------
//
//  $42 - fBNg쐬
//
//---------------------------------------------------------------------------
int FS_MakeDir(const namests_t* pNamests)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	memcpy(&buf[i], pNamests, sizeof(namests_t));
	i += sizeof(namests_t);
	
	return SCSI_SendCmd(buf, i);
}

//---------------------------------------------------------------------------
//
//  $43 - fBNg폜
//
//---------------------------------------------------------------------------
int FS_RemoveDir(const namests_t* pNamests)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	memcpy(&buf[i], pNamests, sizeof(namests_t));
	i += sizeof(namests_t);
	
	return SCSI_SendCmd(buf, i);
}

//---------------------------------------------------------------------------
//
//  $44 - t@CύX
//
//---------------------------------------------------------------------------
int FS_Rename(const namests_t* pNamests, const namests_t* pNamestsNew)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	memcpy(&buf[i], pNamests, sizeof(namests_t));
	i += sizeof(namests_t);

	memcpy(&buf[i], pNamestsNew, sizeof(namests_t));
	i += sizeof(namests_t);
	
	return SCSI_SendCmd(buf, i);
}

//---------------------------------------------------------------------------
//
//  $45 - t@C폜
//
//---------------------------------------------------------------------------
int FS_Delete(const namests_t* pNamests)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	memcpy(&buf[i], pNamests, sizeof(namests_t));
	i += sizeof(namests_t);
	
	return SCSI_SendCmd(buf, i);
}

//---------------------------------------------------------------------------
//
//  $46 - t@C擾/ݒ
//
//---------------------------------------------------------------------------
int FS_Attribute(const namests_t* pNamests, DWORD nHumanAttribute)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	memcpy(&buf[i], pNamests, sizeof(namests_t));
	i += sizeof(namests_t);

	dp = (DWORD*)&buf[i];
	*dp = nHumanAttribute;
	i += sizeof(DWORD);
	
	return SCSI_SendCmd(buf, i);
}

//---------------------------------------------------------------------------
//
//  $47 - t@C
//
//---------------------------------------------------------------------------
int FS_Files(DWORD nKey,
	const namests_t* pNamests, files_t* info)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	dp = (DWORD*)&buf[i];
	*dp = nKey;
	i += sizeof(DWORD);

	memcpy(&buf[i], pNamests, sizeof(namests_t));
	i += sizeof(namests_t);

	memcpy(&buf[i], info, sizeof(files_t));
	i += sizeof(files_t);
	
	return SCSI_CalCmd(buf, i, (BYTE*)info, sizeof(files_t));
}

//---------------------------------------------------------------------------
//
//  $48 - t@C
//
//---------------------------------------------------------------------------
int FS_NFiles(DWORD nKey, files_t* info)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	dp = (DWORD*)&buf[i];
	*dp = nKey;
	i += sizeof(DWORD);

	memcpy(&buf[i], info, sizeof(files_t));
	i += sizeof(files_t);
	
	return SCSI_CalCmd(buf, i, (BYTE*)info, sizeof(files_t));
}

//---------------------------------------------------------------------------
//
//  $49 - t@C쐬
//
//---------------------------------------------------------------------------
int FS_Create(DWORD nKey,
	const namests_t* pNamests, fcb_t* pFcb, DWORD nAttribute, BOOL bForce)
{
	BYTE buf[256];
	DWORD *dp;
	BOOL *bp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	dp = (DWORD*)&buf[i];
	*dp = nKey;
	i += sizeof(DWORD);

	memcpy(&buf[i], pNamests, sizeof(namests_t));
	i += sizeof(namests_t);
	
	memcpy(&buf[i], pFcb, sizeof(fcb_t));
	i += sizeof(fcb_t);

	dp = (DWORD*)&buf[i];
	*dp = nAttribute;
	i += sizeof(DWORD);

	bp = (BOOL*)&buf[i];
	*bp = bForce;
	i += sizeof(BOOL);
	
	return SCSI_CalCmd(buf, i, (BYTE*)pFcb, sizeof(fcb_t));
}

//---------------------------------------------------------------------------
//
//  $4A - t@CI[v
//
//---------------------------------------------------------------------------
int FS_Open(DWORD nKey,
	const namests_t* pNamests, fcb_t* pFcb)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	dp = (DWORD*)&buf[i];
	*dp = nKey;
	i += sizeof(DWORD);

	memcpy(&buf[i], pNamests, sizeof(namests_t));
	i += sizeof(namests_t);
	
	memcpy(&buf[i], pFcb, sizeof(fcb_t));
	i += sizeof(fcb_t);

	return SCSI_CalCmd(buf, i, (BYTE*)pFcb, sizeof(fcb_t));
}

//---------------------------------------------------------------------------
//
//  $4B - t@CN[Y
//
//---------------------------------------------------------------------------
int FS_Close(DWORD nKey, fcb_t* pFcb)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	dp = (DWORD*)&buf[i];
	*dp = nKey;
	i += sizeof(DWORD);
	
	memcpy(&buf[i], pFcb, sizeof(fcb_t));
	i += sizeof(fcb_t);

	return SCSI_CalCmd(buf, i, (BYTE*)pFcb, sizeof(fcb_t));
}

//---------------------------------------------------------------------------
//
//  $4C - t@Cǂݍ
//
//---------------------------------------------------------------------------
int FS_Read(DWORD nKey, fcb_t* pFcb, BYTE* pAddress, DWORD nSize)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	int nResult;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = nKey;
	i += sizeof(DWORD);

	memcpy(&buf[i], pFcb, sizeof(fcb_t));
	i += sizeof(fcb_t);

	dp = (DWORD*)&buf[i];
	*dp = nSize;
	i += sizeof(DWORD);
	
	nResult = SCSI_CalCmd(buf, i, (BYTE*)pFcb, sizeof(fcb_t));

	if (nResult > 0) {
		SCSI_ReadOpt(pAddress, nResult);
	}
	
	return nResult;
}

//---------------------------------------------------------------------------
//
//  $4D - t@C
//
//---------------------------------------------------------------------------
int FS_Write(DWORD nKey, fcb_t* pFcb, BYTE* pAddress, DWORD nSize)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = nKey;
	i += sizeof(DWORD);

	memcpy(&buf[i], pFcb, sizeof(fcb_t));
	i += sizeof(fcb_t);
	
	dp = (DWORD*)&buf[i];
	*dp = nSize;
	i += sizeof(DWORD);

	if (nSize != 0) {
		if (!SCSI_WriteOpt(pAddress, nSize)) {
			return FS_FATAL_MEDIAOFFLINE;
		}
	}
	
	return SCSI_SendCmd(buf, i);
}

//---------------------------------------------------------------------------
//
//  $4E - t@CV[N
//
//---------------------------------------------------------------------------
int FS_Seek(DWORD nKey, fcb_t* pFcb, DWORD nMode, int nOffset)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = nKey;
	i += sizeof(DWORD);

	memcpy(&buf[i], pFcb, sizeof(fcb_t));
	i += sizeof(fcb_t);

	dp = (DWORD*)&buf[i];
	*dp = nMode;
	i += sizeof(DWORD);

	dp = (DWORD*)&buf[i];
	*dp = nOffset;
	i += sizeof(int);
	
	return SCSI_CalCmd(buf, i, (BYTE*)pFcb, sizeof(fcb_t));
}

//---------------------------------------------------------------------------
//
//  $4F - t@C擾/ݒ
//
//---------------------------------------------------------------------------
DWORD FS_TimeStamp(DWORD nKey,
	fcb_t* pFcb, DWORD nHumanTime)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	dp = (DWORD*)&buf[i];
	*dp = nKey;
	i += sizeof(DWORD);

	memcpy(&buf[i], pFcb, sizeof(fcb_t));
	i += sizeof(fcb_t);

	dp = (DWORD*)&buf[i];
	*dp = nHumanTime;
	i += sizeof(DWORD);
	
	return (DWORD)SCSI_CalCmd(buf, i, (BYTE*)pFcb, sizeof(fcb_t));
}

//---------------------------------------------------------------------------
//
//  $50 - eʎ擾
//
//---------------------------------------------------------------------------
int FS_GetCapacity(capacity_t* cap)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	return SCSI_CalCmd(buf, i, (BYTE*)cap, sizeof(capacity_t));
}

//---------------------------------------------------------------------------
//
//  $51 - hCuԌ/
//
//---------------------------------------------------------------------------
int FS_CtrlDrive(ctrldrive_t* pCtrlDrive)
{
#if 1
	// ׂ̂łŎb菈
	switch (pCtrlDrive->status) {
		case 0:		// Ԍ
		case 9:		// Ԍ2
			pCtrlDrive->status = 0x42;
			return pCtrlDrive->status;
		case 1:		// CWFNg
		case 2:		// CWFNg֎~1 ()
		case 3:		// CWFNg1 ()
		case 4:		// fBA}LED_ ()
		case 5:		// fBA}LED ()
		case 6:		// CWFNg֎~2 ()
		case 7:		// CWFNg2 ()
			return 0;

		case 8:		// CWFNg
			return 1;
	}

	return -1;
#else
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	memcpy(&buf[i], pCtrlDrive, sizeof(ctrldrive_t));
	i += sizeof(ctrldrive_t);
	
	return SCSI_CalCmd(buf, i, (BYTE*)pCtrlDrive, sizeof(ctrldrive_t));
#endif
}

//---------------------------------------------------------------------------
//
//  $52 - DPB擾
//
//---------------------------------------------------------------------------
int FS_GetDPB(dpb_t* pDpb)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	return SCSI_CalCmd(buf, i, (BYTE*)pDpb, sizeof(dpb_t));
}

//---------------------------------------------------------------------------
//
//  $53 - ZN^ǂݍ
//
//---------------------------------------------------------------------------
int FS_DiskRead(BYTE* pBuffer, DWORD nSector, DWORD nSize)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	dp = (DWORD*)&buf[i];
	*dp = nSector;
	i += sizeof(DWORD);

	dp = (DWORD*)&buf[i];
	*dp = nSize;
	i += sizeof(DWORD);
	
	return SCSI_CalCmd(buf, i, (BYTE*)pBuffer, 0x200);
}

//---------------------------------------------------------------------------
//
//  $54 - ZN^
//
//---------------------------------------------------------------------------
int FS_DiskWrite()
{
	BYTE buf[256];
	DWORD *dp;
	
	dp = (DWORD*)buf;
	*dp = unit;

	return SCSI_SendCmd(buf, 4);
}

//---------------------------------------------------------------------------
//
//  $55 - IOCTRL
//
//---------------------------------------------------------------------------
int FS_Ioctrl(DWORD nFunction, ioctrl_t* pIoctrl)
{
	BYTE buf[256];
	DWORD *dp;
	int i;
	
	i = 0;
	dp = (DWORD*)buf;
	*dp = unit;
	i += sizeof(DWORD);

	dp = (DWORD*)&buf[i];
	*dp = nFunction;
	i += sizeof(DWORD);

	memcpy(&buf[i], pIoctrl, sizeof(ioctrl_t));
	i += sizeof(ioctrl_t);
	
	return SCSI_CalCmd(buf, i, (BYTE*)pIoctrl, sizeof(ioctrl_t));
}

//---------------------------------------------------------------------------
//
//  $56 - tbV
//
//---------------------------------------------------------------------------
int FS_Flush()
{
#if 1
	// T|[g
	return 0;
#else
	BYTE buf[256];
	DWORD *dp;
	
	dp = (DWORD*)buf;
	*dp = unit;

	return SCSI_SendCmd(buf, 4);
#endif
}

//---------------------------------------------------------------------------
//
//  $57 - fBA`FbN
//
//---------------------------------------------------------------------------
int FS_CheckMedia()
{
#if 1
	// ׂ̂Ŏb菈
	return 0;
#else
	BYTE buf[256];
	DWORD *dp;
	
	dp = (DWORD*)buf;
	*dp = unit;

	return SCSI_SendCmd(buf, 4);
#endif
}

//---------------------------------------------------------------------------
//
//  $58 - r
//
//---------------------------------------------------------------------------
int FS_Lock()
{
#if 1
	// T|[g
	return 0;
#else
	BYTE buf[256];
	DWORD *dp;
	
	dp = (DWORD*)buf;
	*dp = unit;

	return SCSI_SendCmd(buf, 4);
#endif
}

//===========================================================================
//
//	R}hnh
//
//===========================================================================
#define GetReqByte(a) (request[a])
#define SetReqByte(a,d) (request[a] = (d))
#define GetReqWord(a) (*((WORD*)&request[a]))
#define SetReqWord(a,d) (*((WORD*)&request[a]) = (d))
#define GetReqLong(a) (*((DWORD*)&request[a]))
#define SetReqLong(a,d) (*((DWORD*)&request[a]) = (d))
#define GetReqAddr(a) ((BYTE*)((*((DWORD*)&request[a])) & 0x00ffffff))

//---------------------------------------------------------------------------
//
//  NAMESTSǂݍ
//
//---------------------------------------------------------------------------
void GetNameStsPath(BYTE *addr, namests_t* pNamests)
{
	DWORD i;

	ASSERT(this);
	ASSERT(pNamests);

	// ChJ[h
	pNamests->wildcard = *addr;

	// hCuԍ
	pNamests->drive = addr[1];

	// pX
	for (i = 0; i < sizeof(pNamests->path); i++) {
		pNamests->path[i] = addr[2 + i];
	}

	// t@C1
	memset(pNamests->name, 0x20, sizeof(pNamests->name));

	// gq
	memset(pNamests->ext, 0x20, sizeof(pNamests->ext));

	// t@C2
	memset(pNamests->add, 0, sizeof(pNamests->add));
}

//---------------------------------------------------------------------------
//
//  NAMESTSǂݍ
//
//---------------------------------------------------------------------------
void GetNameSts(BYTE *addr, namests_t* pNamests)
{
	DWORD i;

	ASSERT(this);
	ASSERT(pNamests);
	ASSERT(addr <= 0xFFFFFF);

	// ChJ[h
	pNamests->wildcard = *addr;

	// hCuԍ
	pNamests->drive = addr[1];

	// pX
	for (i = 0; i < sizeof(pNamests->path); i++) {
		pNamests->path[i] = addr[2 + i];
	}

	// t@C1
	for (i = 0; i < sizeof(pNamests->name); i++) {
		pNamests->name[i] = addr[67 + i];
	}

	// gq
	for (i = 0; i < sizeof(pNamests->ext); i++) {
		pNamests->ext[i] = addr[75 + i];
	}

	// t@C2
	for (i = 0; i < sizeof(pNamests->add); i++) {
		pNamests->add[i] = addr[78 + i];
	}
}

//---------------------------------------------------------------------------
//
//  FILESǂݍ
//
//---------------------------------------------------------------------------
void GetFiles(BYTE *addr, files_t* pFiles)
{
	ASSERT(this);
	ASSERT(pFiles);
	ASSERT(addr <= 0xFFFFFF);

	// 
	pFiles->fatr = *addr;
	pFiles->sector = *((DWORD*)&addr[2]);
	pFiles->offset = *((WORD*)&addr[8]);;

	pFiles->attr = 0;
	pFiles->time = 0;
	pFiles->date = 0;
	pFiles->size = 0;
	memset(pFiles->full, 0, sizeof(pFiles->full));
}

//---------------------------------------------------------------------------
//
//  FILES
//
//---------------------------------------------------------------------------
void SetFiles(BYTE *addr, const files_t* pFiles)
{
	DWORD i;

	ASSERT(this);
	ASSERT(pFiles);

	*((DWORD*)&addr[2]) = pFiles->sector;
	*((WORD*)&addr[8]) = pFiles->offset;

	// t@C
	addr[21] = pFiles->attr;
	*((WORD*)&addr[22]) = pFiles->time;
	*((WORD*)&addr[24]) = pFiles->date;
	*((DWORD*)&addr[26]) = pFiles->size;

	// tt@C
	addr += 30;
	for (i = 0; i < sizeof(pFiles->full); i++) {
		*addr = pFiles->full[i];
		addr++;
	}
}

//---------------------------------------------------------------------------
//
//  FCBǂݍ
//
//---------------------------------------------------------------------------
void GetFcb(BYTE *addr, fcb_t* pFcb)
{
	ASSERT(this);
	ASSERT(pFcb);

	// FCB
	pFcb->fileptr = *((DWORD*)&addr[6]);
	pFcb->mode = *((WORD*)&addr[14]);

	// 
	pFcb->attr = addr[47];

	// FCB
	pFcb->time = *((WORD*)&addr[58]);
	pFcb->date = *((WORD*)&addr[60]);
	pFcb->size = *((DWORD*)&addr[64]);
}

//---------------------------------------------------------------------------
//
//  FCB
//
//---------------------------------------------------------------------------
void SetFcb(BYTE *addr, const fcb_t* pFcb)
{
	ASSERT(this);
	ASSERT(pFcb);

	// FCB
	*((DWORD*)&addr[6]) = pFcb->fileptr;
	*((WORD*)&addr[14]) = pFcb->mode;

	// 
	addr[47] = pFcb->attr;

	// FCB
	*((WORD*)&addr[58]) = pFcb->time;
	*((WORD*)&addr[60]) = pFcb->date;
	*((DWORD*)&addr[64]) = pFcb->size;
}

//---------------------------------------------------------------------------
//
//  CAPACITY
//
//---------------------------------------------------------------------------
void SetCapacity(BYTE *addr, const capacity_t* pCapacity)
{
	ASSERT(this);
	ASSERT(pCapacity);

	*((WORD*)&addr[0]) = pCapacity->freearea;
	*((WORD*)&addr[2]) = pCapacity->clusters;
	*((WORD*)&addr[4]) = pCapacity->sectors;
	*((WORD*)&addr[6]) = pCapacity->bytes;
}

//---------------------------------------------------------------------------
//
//  DPB
//
//---------------------------------------------------------------------------
void SetDpb(BYTE *addr, const dpb_t* pDpb)
{
	ASSERT(this);
	ASSERT(pDpb);

	// DPB
	*((WORD*)&addr[0]) = pDpb->sector_size;
	addr[2] = 	pDpb->cluster_size;
	addr[3] = 	pDpb->shift;
	*((WORD*)&addr[4]) = pDpb->fat_sector;
	addr[6] = 	pDpb->fat_max;
	addr[7] = 	pDpb->fat_size;
	*((WORD*)&addr[8]) = pDpb->file_max;
	*((WORD*)&addr[10]) = pDpb->data_sector;
	*((WORD*)&addr[12]) = pDpb->cluster_max;
	*((WORD*)&addr[14]) = pDpb->root_sector;
	addr[20] = 	pDpb->media;
}

//---------------------------------------------------------------------------
//
//  IOCTRLǂݍ
//
//---------------------------------------------------------------------------
void GetIoctrl(DWORD param, DWORD func, ioctrl_t* pIoctrl)
{
	DWORD *lp;
	
	ASSERT(this);
	ASSERT(pIoctrl);

	switch (func) {
		case 2:
			// fBAĔF
			pIoctrl->param = param;
			return;

		case -2:
			// IvVݒ
			lp = (DWORD*)param;
			pIoctrl->param = *lp;
			return;
	}
}

//---------------------------------------------------------------------------
//
//  IOCTRL
//
//---------------------------------------------------------------------------
void SetIoctrl(DWORD param, DWORD func, ioctrl_t* pIoctrl)
{
	DWORD i;
	BYTE *bp;
	WORD *wp;
	DWORD *lp;

	ASSERT(this);
	ASSERT(pIoctrl);

	switch (func) {
		case 0:
			// fBAID̊l
			wp = (WORD*)param;
			*wp = pIoctrl->media;
			return;

		case 1:
			// Human68k݊̂߂̃_~[
			lp = (DWORD*)param;
			*lp = pIoctrl->param;
			return;

		case -1:
			// 풓
			bp = (BYTE*)param;
			for (i = 0; i < 8; i++) {
				*bp = pIoctrl->buffer[i];
				bp++;
			}
			return;

		case -3:
			// IvVl
			lp = (DWORD*)param;
			*lp = pIoctrl->param;
			return;
	}
}

//---------------------------------------------------------------------------
//
//  ARGUMENTǂݍ
// 
//  obt@TCYꍇ͓]ł؂ĕKI[B
//
//---------------------------------------------------------------------------
void GetArgument(BYTE *addr, argument_t* pArgument)
{
	BOOL bMode;
	BYTE *p;
	DWORD i;
	BYTE c;

	ASSERT(this);
	ASSERT(pArgument);

	bMode = FALSE;
	p = pArgument->buf;
	for (i = 0; i < sizeof(pArgument->buf) - 2; i++) {
		c = addr[i];
		*p++ = c;
		if (bMode == 0) {
			if (c == '\0')
				return;
			bMode = TRUE;
		} else {
			if (c == '\0')
				bMode = FALSE;
		}
	}

	*p++ = '\0';
	*p = '\0';
}

//---------------------------------------------------------------------------
//
//  Il
//
//---------------------------------------------------------------------------
void SetResult(DWORD nResult)
{
	DWORD code;

	ASSERT(this);

	// vIG[
	switch (nResult) {
		case FS_FATAL_INVALIDUNIT:
			code = 0x5001;
			goto fatal;
		case FS_FATAL_INVALIDCOMMAND:
			code = 0x5003;
			goto fatal;
		case FS_FATAL_WRITEPROTECT:
			code = 0x700D;
			goto fatal;
		case FS_FATAL_MEDIAOFFLINE:
			code = 0x7002;
		fatal:
			SetReqByte(3, (BYTE)code);
			SetReqByte(4, code >> 8);
			//  @note gC\ԂƂ́A(a5 + 18)Ă͂ȂB
			//  ̌㔒т Retry IꍇAlǂݍŌ듮삵Ă܂B
			if (code & 0x2000)
				break;
			nResult = FS_INVALIDFUNC;
		default:
			SetReqLong(18, nResult);
			break;
	}
}

//---------------------------------------------------------------------------
//
//  $40 - foCXN
// 
//	in	(offset	size)
//		 0	1.b	萔(22)
//		 2	1.b	R}h($40/$c0)
//		18	1.l	p[^AhX
//		22	1.b	hCuԍ
//	out	(offset	size)
//		 3	1.b	G[R[h()
//		 4	1.b	V			()
//		13	1.b	jbg
//		14	1.l	foCXhCȍIAhX + 1
//
//    [JhCũR}h 0 ƓlɑgݍݎɌĂ΂邪ABPB y
//  т̃|C^̔zpӂKv͂Ȃ.
//  ̃R}hƈႢÃR}ha5 + 1ɂ͗LȒlĂȂ
//  (0Ȃǂ҂Ă͂Ȃ)̂Œӂ邱ƁB
//
//---------------------------------------------------------------------------
DWORD InitDevice(void)
{
	argument_t arg;
	DWORD units;

	ASSERT(this);
	ASSERT(fs);

	// IvVel
	GetArgument(GetReqAddr(18), &arg);

	// Human68kŗp\ȃhCu͈̔͂ŁAt@CVXe\z
	units = FS_InitDevice(&arg);

	// hCuԐM
	SetReqByte(13, units);

	return 0;
}

//---------------------------------------------------------------------------
//
//  $41 - fBNg`FbN
// 
//	in	(offset	size)
//		14	1.L	NAMESTS\̃AhX
//
//---------------------------------------------------------------------------
DWORD CheckDir(void)
{
	namests_t ns;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// Ώۃt@Cl
	GetNameStsPath(GetReqAddr(14), &ns);

	// t@CVXeĂяo
	nResult = FS_CheckDir(&ns);

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $42 - fBNg쐬
// 
//	in	(offset	size)
//		14	1.L	NAMESTS\̃AhX
//
//---------------------------------------------------------------------------
DWORD MakeDir(void)
{
	namests_t ns;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// Ώۃt@Cl
	GetNameSts(GetReqAddr(14), &ns);

	// t@CVXeĂяo
	nResult = FS_MakeDir(&ns);

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $43 - fBNg폜
// 
//	in	(offset	size)
//		14	1.L	NAMESTS\̃AhX
//
//---------------------------------------------------------------------------
DWORD RemoveDir(void)
{
	namests_t ns;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// Ώۃt@Cl
	GetNameSts(GetReqAddr(14), &ns);

	// t@CVXeĂяo
	nResult = FS_RemoveDir(&ns);

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $44 - t@CύX
// 
//	in	(offset	size)
//		14	1.L	NAMESTS\̃AhX t@C
//		18	1.L	NAMESTS\̃AhX Vt@C
//
//---------------------------------------------------------------------------
DWORD Rename(void)
{
	namests_t ns;
	namests_t ns_new;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// Ώۃt@Cl
	GetNameSts(GetReqAddr(14), &ns);
	GetNameSts(GetReqAddr(18), &ns_new);

	// t@CVXeĂяo
	nResult = FS_Rename(&ns, &ns_new);

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $45 - t@C폜
// 
//	in	(offset	size)
//		14	1.L	NAMESTS\̃AhX
//
//---------------------------------------------------------------------------
DWORD Delete(void)
{
	namests_t ns;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// Ώۃt@Cl
	GetNameSts(GetReqAddr(14), &ns);

	// t@CVXeĂяo
	nResult = FS_Delete(&ns);

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $46 - t@C擾/ݒ
// 
//	in	(offset	size)
//		12	1.B	ǂݏo0x01ɂȂ̂Œ
//		13	1.B	 $FFƓǂݏo
//		14	1.L	NAMESTS\̃AhX
//
//---------------------------------------------------------------------------
DWORD Attribute(void)
{
	namests_t ns;
	DWORD attr;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// Ώۃt@Cl
	GetNameSts(GetReqAddr(14), &ns);

	// Ώۑ
	attr = GetReqByte(13);

	// t@CVXeĂяo
	nResult = FS_Attribute(&ns, attr);

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $47 - t@C
// 
//	in	(offset	size)
//		 0	1.b	萔(26)
//		 1	1.b	jbgԍ
//		 2	1.b	R}h($47/$c7)
//		13	1.b	 (WindrvXMł͖gpBobt@ɒlĂ)
//		14	1.l	t@Cobt@(namests `)
//		18	1.l	obt@(files `) ̃obt@Ɍrƌʂ
//	out	(offset	size)
//		 3	1.b	G[R[h()
//		 4	1.b	V			()
//		18	1.l	UgXe[^X
//
//    fBNgwt@C. DOS _FILES Ăяo.
//    ɎsꍇAႵ͌ɐĂChJ[hg
//  Ȃꍇ́A񌟍ɕKsׂɌobt@̃ItZbg
//  -1 . ꍇ͌t@C̏ݒ肷
//  ƋɁAp̏̃ZN^ԍAItZbgA[gfBNg̏
//  ͍XɎcZN^ݒ肷. hCuEApX DOS R[
//  Őݒ肳̂ŏޕKv͂Ȃ.
//
//	<NAMESTS\>
//	(offset	size)
//	0	 1.b	NAMWLD	0:ChJ[hȂ -1:t@CwȂ
//				(ChJ[h̕)
//	1	 1.b	NAMDRV	hCuԍ(A=0,B=1,c,Z=25)
//	2	65.b	NAMPTH	pX('\'{΃TufBNg{'\')
//	67	 8.b	NAMNM1	t@C(擪 8 )
//	75	 3.b	NAMEXT	gq
//	78	10.b	NAMNM2	t@C(c 10 )
//
//  pX؂蕶0x2F(/)0x5C(\)ł͂Ȃ0x09(TAB)gĂ̂ŒӁB
//
//---------------------------------------------------------------------------
DWORD Files(void)
{
	BYTE *files;
	files_t info;
	namests_t ns;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// roߊi[̈
	files = GetReqAddr(18);
	GetFiles(files, &info);

	// Ώۃt@Cl
	GetNameSts(GetReqAddr(14), &ns);

	// t@CVXeĂяo
	nResult = FS_Files((DWORD)files, &ns, &info);

	// ʂ̔f
	if (nResult >= 0) {
		SetFiles(files, &info);
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $48 - t@C
// 
//	in	(offset	size)
//		18	1.L	FILES\̃AhX
//
//---------------------------------------------------------------------------
DWORD NFiles(void)
{
	BYTE *files;
	files_t info;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// [N̈̓ǂݍ
	files = GetReqAddr(18);
	GetFiles(files, &info);

	// t@CVXeĂяo
	nResult = FS_NFiles((DWORD)files, &info);

	// ʂ̔f
	if (nResult >= 0) {
		SetFiles(files, &info);
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $49 - t@C쐬(Create)
// 
//	in	(offset	size)
//		 1	1.B	jbgԍ
//		13	1.B	
//		14	1.L	NAMESTS\̃AhX
//		18	1.L	[h (0:_NEWFILE 1:_CREATE)
//		22	1.L	FCB\̃AhX
//
//---------------------------------------------------------------------------
DWORD Create(void)
{
	namests_t ns;
	BYTE *pFcb;
	fcb_t fcb;
	DWORD attr;
	BOOL force;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// Ώۃt@Cl
	GetNameSts(GetReqAddr(14), &ns);

	// FCBl
	pFcb = GetReqAddr(22);
	GetFcb(pFcb, &fcb);

	// 
	attr = GetReqByte(13);

	// ㏑[h
	force = (BOOL)GetReqLong(18);

	// t@CVXeĂяo
	nResult = FS_Create((DWORD)pFcb, &ns, &fcb, attr, force);

	// ʂ̔f
	if (nResult >= 0) {
		SetFcb(pFcb, &fcb);
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $4A - t@CI[v
// 
//	in	(offset	size)
//		 1	1.B	jbgԍ
//		14	1.L	NAMESTS\̃AhX
//		22	1.L	FCB\̃AhX
//				FCBɂ͂قƂǂ̃p[^ݒς
//				Et̓I[vuԂ̂̂ɂȂĂ̂ŏ㏑
//				TCY0ɂȂĂ̂ŏ㏑
//
//---------------------------------------------------------------------------
DWORD Open(void)
{
	namests_t ns;
	BYTE *pFcb;
	fcb_t fcb;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// Ώۃt@Cl
	GetNameSts(GetReqAddr(14), &ns);

	// FCBl
	pFcb = GetReqAddr(22);
	GetFcb(pFcb, &fcb);

	// t@CVXeĂяo
	nResult = FS_Open((DWORD)pFcb, &ns, &fcb);

	// ʂ̔f
	if (nResult >= 0) {
		SetFcb(pFcb, &fcb);
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $4B - t@CN[Y
// 
//	in	(offset	size)
//		22	1.L	FCB\̃AhX
//
//---------------------------------------------------------------------------
DWORD Close(void)
{
	BYTE *pFcb;
	fcb_t fcb;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// FCBl
	pFcb = GetReqAddr(22);
	GetFcb(pFcb, &fcb);

	// t@CVXeĂяo
	nResult = FS_Close((DWORD)pFcb, &fcb);

	// ʂ̔f
	if (nResult >= 0) {
		SetFcb(pFcb, &fcb);
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $4C - t@Cǂݍ
// 
//	in	(offset	size)
//		14	1.L	ǂݍ݃obt@ Ƀt@Ceǂݍ
//		18	1.L	TCY 16MB𒴂lw肳\
//		22	1.L	FCB\̃AhX
//
//  oXG[AhXw肵ꍇ͕̓ۏ؂ȂB
// 
//  20ĨAv́u̐ƃt@CSǂށvƂ@ŏĂ
//  \B[H̃t@C16MBĂ[H(CV.R݂Ȃ)
// 
//  ނ4`12MB炢̓̃vO}[猩Iȁuv̒l
//  Nbv悤Ȕzł͕KvȂ̂ł͂Ȃ낤B
//  ܂́A12MB16MBʒu𒴂TCYNbvƗǂB
//
//---------------------------------------------------------------------------
DWORD Read(void)
{
	BYTE *pFcb;
	fcb_t fcb;
	BYTE *pAddress;
	DWORD nSize;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// FCBl
	pFcb = GetReqAddr(22);
	GetFcb(pFcb, &fcb);

	// ǂݍ݃obt@
	pAddress = GetReqAddr(14);

	// ǂݍ݃TCY
	nSize = GetReqLong(18);

	// NbsO
	if (nSize >= WINDRV_CLIPSIZE_MAX) {
		nSize = WINDRV_CLIPSIZE_MAX;
	}

	// t@CVXeĂяo
	nResult = FS_Read((DWORD)pFcb, &fcb, pAddress, nSize);

	// ʂ̔f
	if (nResult >= 0) {
		SetFcb(pFcb, &fcb);
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $4D - t@C
// 
//	in	(offset	size)
//		14	1.L	݃obt@ Ƀt@Ce
//		18	1.L	TCY ̐Ȃt@CTCYw肵̂Ɠ
//		22	1.L	FCB\̃AhX
//
//  oXG[AhXw肵ꍇ͕̓ۏ؂ȂB
//
//---------------------------------------------------------------------------
DWORD Write(void)
{
	BYTE *pFcb;
	fcb_t fcb;
	BYTE *pAddress;
	DWORD nSize;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// FCBl
	pFcb = GetReqAddr(22);
	GetFcb(pFcb, &fcb);

	// ݃obt@
	pAddress = GetReqAddr(14);

	// ݃TCY
	nSize = GetReqLong(18);

	// NbsO
	if (nSize >= WINDRV_CLIPSIZE_MAX) {
		nSize = WINDRV_CLIPSIZE_MAX;
	}

	// t@CVXeĂяo
	nResult = FS_Write((DWORD)pFcb, &fcb, pAddress, nSize);

	// ʂ̔f
	if (nResult >= 0) {
		SetFcb(pFcb, &fcb);
	}
	
	return nResult;
}

//---------------------------------------------------------------------------
//
//  $4E - t@CV[N
// 
//	in	(offset	size)
//		12	1.B	0x2B ɂȂĂƂ 0̂Ƃ
//		13	1.B	[h
//		18	1.L	ItZbg
//		22	1.L	FCB\̃AhX
//
//---------------------------------------------------------------------------
DWORD Seek(void)
{
	BYTE *pFcb;
	fcb_t fcb;
	DWORD nMode;
	DWORD nOffset;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// FCBl
	pFcb = GetReqAddr(22);
	GetFcb(pFcb, &fcb);

	// V[N[h
	nMode = GetReqByte(13);

	// V[NItZbg
	nOffset = GetReqLong(18);

	// t@CVXeĂяo
	nResult = FS_Seek((DWORD)pFcb, &fcb, nMode, nOffset);

	// ʂ̔f
	if (nResult >= 0) {
		SetFcb(pFcb, &fcb);
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $4F - t@C擾/ݒ
// 
//	in	(offset	size)
//		18	1.W	DATE
//		20	1.W	TIME
//		22	1.L	FCB\̃AhX
//
//  FCBǂݍ݃[hŊJꂽԂłݒύX\B
//  FCBł͏݋֎~̔肪łȂ̂ŒӁB
//
//---------------------------------------------------------------------------
DWORD TimeStamp(void)
{
	BYTE *pFcb;
	fcb_t fcb;
	DWORD nTime;
	DWORD nResult;

	ASSERT(this);
	ASSERT(fs);

	// FCBl
	pFcb = GetReqAddr(22);
	GetFcb(pFcb, &fcb);

	// l
	nTime = GetReqLong(18);

	// t@CVXeĂяo
	nResult = FS_TimeStamp((DWORD)pFcb, &fcb, nTime);

	// ʂ̔f
	if (nResult < 0xFFFF0000) {
		SetFcb(pFcb, &fcb);
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $50 - eʎ擾
// 
//	in	(offset	size)
//		 0	1.b	萔(26)
//		 1	1.b	jbgԍ
//		 2	1.b	R}h($50/$d0)
//		14	1.l	obt@AhX
//	out	(offset	size)
//		 3	1.b	G[R[h()
//		 4	1.b	V			()
//		18	1.l	UgXe[^X
//
//    fBȂe/󂫗eʁANX^/ZN^TCY. obt@
//  ɏޓe͈ȉ̒ʂ. UgXe[^XƂĎgp\ȃoCg
//  Ԃ.
//
//	(offset	size)
//	0	1.w	gp\ȃNX^
//	2	1.w	NX^
//	4	1.w	1 NX^̃ZN^
//	6	1.w	1 ZN^̃oCg
//
//---------------------------------------------------------------------------
DWORD GetCapacity(void)
{
	BYTE *pCapacity;
	capacity_t cap;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// obt@擾
	pCapacity = GetReqAddr(14);

#if 0
	// t@CVXeĂяo
	nResult = FS_GetCapacity(&cap);
#else
	// eԂĂ̂ŃXLbvĂ݂
	cap.freearea = 0xFFFF;
	cap.clusters = 0xFFFF;
	cap.sectors = 64;
	cap.bytes = 512;
	nResult = 0x7FFF8000;
#endif

	// ʂ̔f
	if (nResult >= 0) {
		SetCapacity(pCapacity, &cap);
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $51 - hCuԌ/
// 
//	in	(offset	size)
//		 1	1.B	jbgԍ
//		13	1.B		0: Ԍ 1: CWFNg
//
//---------------------------------------------------------------------------
DWORD CtrlDrive(void)
{
	ctrldrive_t ctrl;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// hCuԎ擾
	ctrl.status = GetReqByte(13);

	// t@CVXeĂяo
	nResult = FS_CtrlDrive(&ctrl);

	// ʂ̔f
	if (nResult >= 0) {
		SetReqByte(13, ctrl.status);
	}
	
	return nResult;
}

//---------------------------------------------------------------------------
//
//  $52 - DPB擾
// 
//	in	(offset	size)
//		 0	1.b	萔(26)
//		 1	1.b	jbgԍ
//		 2	1.b	R}h($52/$d2)
//		14	1.l	obt@AhX(擪AhX + 2 w)
//	out	(offset	size)
//		 3	1.b	G[R[h()
//		 4	1.b	V			()
//		18	1.l	UgXe[^X
//
//    w胁fBȀ v1 ` DPB ŕԂ. ̃R}hŐݒ肷Kv
//  ͈ȉ̒ʂ(ʓ DOS R[ݒ肷). Aobt
//  @AhX̓ItZbg 2 wAhXn̂Œӂ邱.
//
//	(offset	size)
//	 0	1.b	(hCuԍ)
//	 1	1.b	(jbgԍ)
//	 2	1.w	1 ZN^̃oCg
//	 4	1.b	1 NX^̃ZN^ - 1
//	 5	1.b	NX^ZN^̃Vtg
//			bit 7 = 1  MS-DOS ` FAT(16bit Intel z)
//	 6	1.w	FAT ̐擪ZN^ԍ
//	 8	1.b	FAT ̈̌
//	 9	1.b	FAT ̐߂ZN^(ʕ)
//	10	1.w	[gfBNgɓt@Č
//	12	1.w	f[^̈̐擪ZN^ԍ
//	14	1.w	NX^ + 1
//	16	1.w	[gfBNg̐擪ZN^ԍ
//	18	1.l	(hCowb_̃AhX)
//	22	1.b	(̕hCu)
//	23	1.b	(DPB gptO: 0)
//	24	1.l	( DPB ̃AhX)
//	28	1.w	(JgfBNg̃NX^ԍ: 0)
//	30	64.b	(JgfBNg)
//
//---------------------------------------------------------------------------
DWORD GetDPB(void)
{
	BYTE *pDpb;
	dpb_t dpb;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// DPB擾
	pDpb = GetReqAddr(14);

	// t@CVXeĂяo
	nResult = FS_GetDPB(&dpb);

	// ʂ̔f
	if (nResult >= 0) {
		SetDpb(pDpb, &dpb);
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $53 - ZN^ǂݍ
// 
//	in	(offset	size)
//		 1	1.B	jbgԍ
//		14	1.L	obt@AhX
//		18	1.L	ZN^
//		22	1.L	ZN^ԍ
//
//---------------------------------------------------------------------------
DWORD DiskRead(void)
{
	BYTE *pAddress;
	DWORD nSize;
	DWORD nSector;
	BYTE buffer[0x200];
	int nResult;
	int i;

	ASSERT(this);
	ASSERT(fs);

	pAddress = GetReqAddr(14);	// AhX (ʃrbggtO)
	nSize = GetReqLong(18);		// ZN^
	nSector = GetReqLong(22);	// ZN^ԍ

	// t@CVXeĂяo
	nResult = FS_DiskRead(buffer, nSector, nSize);

	// ʂ̔f
	if (nResult >= 0) {
		for (i = 0; i < sizeof(buffer); i++) {
			*pAddress = buffer[i];
			pAddress++;
		}
	}

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $54 - ZN^
// 
//	in	(offset	size)
//		 1	1.B	jbgԍ
//		14	1.L	obt@AhX
//		18	1.L	ZN^
//		22	1.L	ZN^ԍ
//
//---------------------------------------------------------------------------
DWORD DiskWrite(void)
{
	BYTE *pAddress;
	DWORD nSize;
	DWORD nSector;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	pAddress = GetReqAddr(14);	// AhX(ʃrbggtO)
	nSize = GetReqLong(18);		// ZN^
	nSector = GetReqLong(22);	// ZN^ԍ

	// t@CVXeĂяo
	nResult = FS_DiskWrite();

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $55 - IOCTRL
// 
//	in	(offset	size)
//		 1	1.B	jbgԍ
//		14	1.L	p[^
//		18	1.W	@\ԍ
//
//---------------------------------------------------------------------------
DWORD Ioctrl(void)
{
	DWORD param;
	DWORD func;
	ioctrl_t ioctrl;
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// IOCTRL擾
	param = GetReqLong(14);		// p[^
	func = GetReqWord(18);		// @\ԍ
	GetIoctrl(param, func, &ioctrl);

	// t@CVXeĂяo
	nResult = FS_Ioctrl(func, &ioctrl);

	// ʂ̔f
	if (nResult >= 0)
		SetIoctrl(param, func, &ioctrl);

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $56 - tbV
// 
//	in	(offset	size)
//		 1	1.B	jbgԍ
//
//---------------------------------------------------------------------------
DWORD Flush(void)
{
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// t@CVXeĂяo
	nResult = FS_Flush();

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $57 - fBA`FbN
// 
//	in	(offset	size)
//		 0	1.b	萔(26)
//		 1	1.b	jbgԍ
//		 2	1.b	R}h($57/$d7)
//	out	(offset	size)
//		 3	1.b	G[R[h()
//		 4	1.b	V			()
//		18	1.l	UgXe[^X
//
//    fBAꂽۂ𒲂ׂ. Ăꍇ̃tH[}bg
//  mF͂̃R}hōs.
//
//---------------------------------------------------------------------------
DWORD CheckMedia(void)
{
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// t@CVXeĂяo
	nResult = FS_CheckMedia();

	return nResult;
}

//---------------------------------------------------------------------------
//
//  $58 - r
// 
//	in	(offset	size)
//		 1	1.B	jbgԍ
//
//---------------------------------------------------------------------------
DWORD Lock(void)
{
	int nResult;

	ASSERT(this);
	ASSERT(fs);

	// t@CVXeĂяo
	nResult = FS_Lock();

	return nResult;
}

//---------------------------------------------------------------------------
//
//  R}hs
//
//---------------------------------------------------------------------------
DWORD ExecuteCommand()
{
	ASSERT(this);

	// G[NA
	SetReqByte(3, 0);
	SetReqByte(4, 0);

	// R}hԍ
	command = (DWORD)GetReqByte(2);	// rbg7̓xt@CtO

	// jbgԍ
	unit = GetReqByte(1);

	// R}h
	switch (command & 0x7F) {
		case 0x40: return InitDevice();	// $40 - foCXN
		case 0x41: return CheckDir();	// $41 - fBNg`FbN
		case 0x42: return MakeDir();	// $42 - fBNg쐬
		case 0x43: return RemoveDir();	// $43 - fBNg폜
		case 0x44: return Rename();		// $44 - t@CύX
		case 0x45: return Delete();		// $45 - t@C폜
		case 0x46: return Attribute();	// $46 - t@C擾/ݒ
		case 0x47: return Files();		// $47 - t@C
		case 0x48: return NFiles();		// $48 - t@C
		case 0x49: return Create();		// $49 - t@C쐬
		case 0x4A: return Open();		// $4A - t@CI[v
		case 0x4B: return Close();		// $4B - t@CN[Y
		case 0x4C: return Read();		// $4C - t@Cǂݍ
		case 0x4D: return Write();		// $4D - t@C
		case 0x4E: return Seek();		// $4E - t@CV[N
		case 0x4F: return TimeStamp();	// $4F - t@CXV̎擾/ݒ
		case 0x50: return GetCapacity();// $50 - eʎ擾
		case 0x51: return CtrlDrive();	// $51 - hCu/Ԍ
		case 0x52: return GetDPB();		// $52 - DPB擾
		case 0x53: return DiskRead();	// $53 - ZN^ǂݍ
		case 0x54: return DiskWrite();	// $54 - ZN^
		case 0x55: return Ioctrl();		// $55 - IOCTRL
		case 0x56: return Flush();		// $56 - tbV
		case 0x57: return CheckMedia();	// $57 - fBA`FbN
		case 0x58: return Lock();		// $58 - r
	}

	return FS_FATAL_INVALIDCOMMAND;
}

//---------------------------------------------------------------------------
//
//  
//
//---------------------------------------------------------------------------
BOOL Init()
{
	ASSERT(this);

	return SCSI_Init();
}

//---------------------------------------------------------------------------
//
//  s
//
//---------------------------------------------------------------------------
void Process(DWORD nA5)
{
	ASSERT(this);
	ASSERT(nA5 <= 0xFFFFFF);
	ASSERT(m_bAlloc);
	ASSERT(m_bFree);

	// NGXgwb_̃AhX
	request = (BYTE*)nA5;

	// R}hs
	SetResult(ExecuteCommand());
}
