**---------------------------------------------------------------------------
**
**  SCSI Target Emulator RaSCSI (*^..^*)
**  for Raspberry Pi
**
**  Powered by XM6 TypeG Technorogy.
**  Copyright (C) 2016-2017 GIMONS
**	[ RaSCSI C[T[lbg hCo ]
**
**  Based on
**    Neptune-X board driver for  Human-68k(ESP-X)   version 0.03
**    Programed 1996-7 by Shi-MAD.
**    Special thanks to  Niggle, FIRST, yamapu ...
**
**---------------------------------------------------------------------------

* Include Files ----------------------- *

	.include	doscall.mac
	.include	iocscall.mac


* Global Symbols ---------------------- *

*
* bp O錾
*
	.xref	_Initialize, _AddList, _SearchList, _DeleteList		;main.c  
	.xref	_GetMacAddr, _SetMacAddr							;scsictl.c
	.xref	_SendPacket, _SetPacketReception 					;scsictl.c
*	.xref	_AddMulticastAddr, _DelMulticastAddr				;

*
* bp Oϐ
*
	.xref	_num_of_prt		;main.c o^vgR
	.xref	_trap_no		;gptrapio[
	.xref	_trans_counter	;scsictl.c M/MoCg
	.xref	_intr_type		;scsictl.c 荞ݎ
	.xref	_poll_interval	;scsictl.c |[OԊu


* Text Section -------------------------------- *

	.cpu	68000
	.text


*
* foCXwb_[
*
device_header:
	.dc.l	-1					;N|C^[
	.dc	$8000					;device att.
	.dc.l	strategy_entry		;stategy entry
	.dc.l	interupt_entry		;interupt entry
	.dc.b	'/dev/en0'			;device name
	.dc.b	'EthD'				;for etherlib.a
	.dc.b	'RASC'				;driver name (̌ɃGg[u)

* 'RASC'  superjsr_entry ̊Ԃɂ͉uȂ

*
* C[ThCo ֐ Gg[ ( for  DOS _SUPERJSR )
*   in: d0:	command number
*	a0:	args
*
superjsr_entry:
	movem.l	d1-d7/a1-a7,-(sp)

*	move.l	d0,-(sp)
*	pea	(mes11,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	move.l	(sp)+,d0
*	.data
*mes11:	.dc.b	'en0:spjEntry',13,10,0
*	.text

	bsr	do_command
	movem.l	(sp)+,d1-d7/a1-a7
	rts				;ʂ̃^[


*
* C[ThCo ֐ Gg[ ( for  trap #n )
*   in: d0:	command number
*	a0:	args
*
_trap_entry::
	movem.l	d1-d7/a1-a7,-(sp)

*	move.l	d0,-(sp)
*	pea	(mes10,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	move.l	(sp)+,d0
*	.data
*mes10:	.dc.b	'en0:trapEntry',13,10,0
*	.text

	bsr	do_command
	movem.l	(sp)+,d1-d7/a1-a7
	rte				;荞݃^[


*
* eӂ킯
*
do_command:
	moveq	#FUNC_MIN,d1
	cmp.l	d0,d1
	bgt	error			;d0<-2 Ȃ疢ΉR}hԍ
	moveq	#FUNC_MAX,d1
	cmp.l	d1,d0
	bgt	error			;9<d0 Ȃ疢ΉR}hԍ

	add	d0,d0
	move	(jumptable,pc,d0.w),d0
	jmp	(jumptable,pc,d0.w)	; a0 WX^n
**	rts
error:
	moveq	#-1,d0
	rts

*
* Wve[u
*

FUNC_MIN:	.equ	($-jumptable)/2
	.dc	get_cnt_addr-jumptable			;-2 ... MJE^̃AhX擾
	.dc	driver_entry-jumptable			;-1 ... gptrapԍ̎擾
jumptable:
	.dc	get_driver_version-jumptable	;00 ... o[W̎擾
	.dc	get_mac_addr-jumptable			;01 ... ݂MACAhX擾
	.dc	get_prom_addr-jumptable			;02 ... PROMɏꂽMACAhX擾
	.dc	set_mac_addr-jumptable			;03 ... MACAhX̐ݒ
	.dc	send_packet-jumptable			;04 ... pPbgM
	.dc	set_int_addr-jumptable			;05 ... pPbgMnhݒ
	.dc	get_int_addr-jumptable			;06 ... pPbgMnh̃AhX擾
	.dc	del_int_addr-jumptable			;07 ... nh폜
	.dc	set_multicast_addr-jumptable	;08 ... (}`LXg̐ݒ聃Ή)
	.dc	get_statistics-jumptable		;09 ... (vǂݏoΉ)
FUNC_MAX:	.equ	($-jumptable)/2-1


*
* R}h -2: MJE^̃AhXԂ
*  return: address
*
get_cnt_addr:
	pea	(_trans_counter,pc)
	move.l	(sp)+,d0
	rts


*
* R}h -1: gptrapԍԂ
*  return: trap number to use (-1:use SUPERJSR)
*
driver_entry:
*	pea	(mesff,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	.data
*mesff:	.dc.b	'DriverEntry',13,10,0
*	.text

	move.l	(_trap_no,pc),d0	;trap_no ... main.c ϐ
	rts


*
* R}h 00: hCo[̃o[WԂ
*  return: version number (... ver1.00 Ȃ 100 Ԃ)
*
get_driver_version:
*	pea	(mes00,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	.data
*mes00:	.dc.b	'GetDriverVersion',13,10,0
*	.text

	moveq	#3,d0			;ver 0.03
	rts


*
* R}h 01: ݂ MAC AhX̎擾
*  return: same as *dst
*
get_mac_addr:
*	pea	(mes01,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	.data
*mes01:	.dc.b	'GetMacAddr',13,10,0
*	.text

	pea	(a0)
	pea	(a0)
	bsr	_GetMacAddr		;scsictl.c ֐
	addq.l	#4,sp
	move.l	(sp)+,d0		; a0  d0 ɂ̂܂ܕԂ
	rts

*
* R}h 02: EEPROM ɏꂽ MAC AhX̎擾
*  return: same as *dst
*
get_prom_addr:
*	pea	(mes02,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	.data
*mes02:	.dc.b	'GePromAddr',13,10,0
*	.text

	pea	(a0)
	pea	(a0)
	bsr	_GetMacAddr		;scsictl.c ֐
	addq.l	#4,sp
	move.l	(sp)+,d0		; a0  d0 ɂ̂܂ܕԂ
	rts

*
* R}h 03: MACAhX̐ݒ
*  return: 0 (if no errors)
*
set_mac_addr:
*	pea	(mes03,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	.data
*mes03:	.dc.b	'SetMacAddr',13,10,0
*	.text

	pea	(a0)
	bsr	_SetMacAddr		;scsictl.c ֐
	addq.l	#4,sp
	rts


*
* R}h 04: pPbgM
*   packet contents:
*	Distination MAC: 6 bytes
*	Source(own) MAC: 6 bytes
*	Protcol type:    2 bytes
*	Data:            ? bytes
*  return: 0 (if no errors)
*
send_packet:
*	pea	(mes04,pc)
*	DOS	_PRINT
*	addq.l	#4,sp

	move.l	(a0)+,d0		;pPbgTCY
	move.l	(a0),-(sp)		;pPbgAhX
	move.l	d0,-(sp)
	bsr	_SendPacket		;scsictl.c ֐
	addq.l	#8,sp

*	move.l	d0,-(sp)
*	pea	(mes04e,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	move.l	(sp)+,d0
*	.data
*mes04:	.dc.b	13,10,'SendPacket,13,10',0
*mes04e:.dc.b	13,10,'SendPacket',13,10,0
*	.text

	rts


*
* R}h 05: M荞݃nhǉEݒ
*   type: 0x00000800 IP packet
*         0x00000806 ARP packet
*  return: 0 (if no errors)
*
set_int_addr:
*	pea	(mes05,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	.data
*mes05:	.dc.b	'SetIntAddr',13,10,0
*	.text

	move.l	(a0)+,d0		;vgRԍ
	move.l	(a0),-(sp)		;nh֐̃AhX
	move.l	d0,-(sp)
	bsr	_AddList		;main.c ֐
	addq.l	#8,sp
	tst.l	d0
	bmi	set_int_addr_rts	;o^s

	cmpi.l	#1,(_num_of_prt)	;nhPȂ犄荞݋
	bne	set_int_addr_rts

	pea	(1)			;1=<>
	bsr	_SetPacketReception	;荞݋ ... scsictl.c
	addq.l	#4,sp

*	moveq	#0,d0			;SetPacketReception() ŏ 0 Ԃ̂ŏȗ
set_int_addr_rts:
	rts


*
* R}h 06: 荞݃nh̃AhX擾
*  return: interupt address
*
get_int_addr:
*	pea	(mes07,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	.data
*mes07:	.dc.b	'GetIntAddr',13,10,0
*	.text

	pea	(a0)
	bsr	_SearchList
	addq.l	#4,sp
	rts


*
* R}h 07: 荞݃nh̍폜
*  return: 0 (if no errors)
*
del_int_addr:
*	pea	(mes06,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	.data
*mes06:	.dc.b	'DelIntAddr',13,10,0
*	.text

	pea	(a0)
	bsr	_DeleteList		;main.c ֐
	move.l	d0,(sp)+
	bmi	del_int_addr_ret	;폜s

	tst.l	(_num_of_prt)		;nhȂȂΊ荞݂֎~
	bne	del_int_addr_ret

	clr.l	-(sp)			;0=<֎~>
	bsr	_SetPacketReception	;荞݋֎~ ... scsictl.c
	addq.l	#4,sp

*	moveq	#0,d0			;SetPacketReception() ŏ 0 Ԃ̂ŏȗ
del_int_addr_ret:
	rts


*
* R}h 08: }`LXgAhX̐ݒ
*
set_multicast_addr:
*	pea	(mes08,pc)
*	.data
*	DOS	_PRINT
*	addq.l	#4,sp
*mes08:	.dc.b	'SetMulticastAddr',13,10,0
*	.text

	moveq	#0,d0
	rts


*
* R}h 09: vǂݏo
*
get_statistics:
*	pea	(mes09,pc)
*	DOS	_PRINT
*	addq.l	#4,sp
*	.data
*mes09:	.dc.b	'GetStatistics',13,10,0
*	.text

	moveq	#0,d0
	rts

*
* foCXhCoGg[
*
strategy_entry:
	move.l	a5,(request_buffer)
	rts


interupt_entry:
	move.l	sp,(stack_buff)		;ÕX^bNGAg
	lea	(def_stack),sp		;

	movem.l	d1-d7/a0-a5,-(sp)
	movea.l	(request_buffer,pc),a5
	tst.b	(2,a5)
	bne	errorret

	pea	(mestitle,pc)
	DOS	_PRINT
	addq.l	#4,sp
	movea.l	(18,a5),a4
@@:
	tst.b	(a4)+
	bne	@b

	moveq	#0,d0
	move.l	d0,(_trap_no)
	move.l	d0,(_intr_type)
	moveq	#1,d0
	move.l	d0,(_poll_interval)

arg_loop:
	move.b	(a4)+,d0
	beq	arg_end
	cmpi.b	#'-',d0
	beq	@f
	cmpi.b	#'/',d0
	bne	param_errret
@@:
	move.b	(a4)+,d0
	beq	param_errret
opt_loop:
	andi.b	#$df,d0
	cmpi.b	#'I',d0
	beq	opt_i
	cmpi.b	#'P',d0
	beq	opt_p
	cmpi.b	#'T',d0
	beq	opt_t
	cmpi.b	#'N',d0
	beq	opt_n
	bra	param_errret

opt_n:
	moveq	#-1,d0
	move.l	d0,(_trap_no)
	move.b	(a4)+,d0
	beq	arg_loop
	bra	opt_loop

opt_t:
	bsr	get_num
	tst.b	d0
	bne	param_errret
	cmpi	#6,d2
	bgt	param_errret
	move.l	d2,(_trap_no)
	move.b	(a4)+,d0
	beq	arg_loop
	bra	opt_loop

opt_p:
	bsr	get_num
	tst.b	d0
	bne	param_errret
	cmpi	#1,d2
	blt	param_errret
	cmpi	#8,d2
	bgt	param_errret
	move.l	d2,(_poll_interval)
	move.b	(a4)+,d0
	beq	arg_loop
	bra	opt_loop

opt_i:
	bsr	get_num
	tst.b	d0
	bne	param_errret
	cmpi	#1,d2
	bgt	param_errret
	move.l	d2,(_intr_type)
	move.b	(a4)+,d0
	beq	arg_loop
	bra	opt_loop

arg_end:
	bsr	_Initialize		;main.c ֐
				;I/OAhXݒ
				;MACAhX擾
				;vgRXg
				;SCSICTL
				;荞݃nhixN^ݒj
				;trapT[rXixN^ݒj
	tst.l	d0
	bne	errorret

*	moveq	#0,d0
	move.l	#prog_end,(14,a5)
	bra	intret


param_errret:
	pea	(mesparam_err,pc)
	DOS	_PRINT
	addq.l	#4,sp
errorret:
	move	#$5003,d0
intret:
	move.b	d0,(4,a5)
	lsr	#8,d0
	move.b	d0,(3,a5)
	movem.l	(sp)+,d1-d7/a0-a5

	movea.l	(stack_buff,pc),sp	;X^bN|C^ɂǂ
	rts

get_num:
	moveq	#1,d0
	moveq	#0,d1
	moveq	#0,d2
@@:
	move.b	(a4),d1
	subi.b	#'0',d1
	bcs	@f
	cmpi.b	#9,d1
	bgt	@f
	move.b	#0,d0
	andi	#$f,d1
	mulu	#10,d2
	add	d1,d2
	addq.l	#1,a4
	bra	@b
@@:
	rts


* Data Section ------------------------ *

	.data
mestitle:
	.dc.b	13,10
	.dc.b	'RaSCSI Ethernet Driver version 1.20 / Based on ether_ne.sys+M01L12',13,10
	.dc.b	0
mesparam_err:
	.dc.b	'p[^ُł',13,10,0
	.even


* BSS --------------------------------- *

	.bss
	.quad

stack_buff:
	.ds.l	1
request_buffer:
	.ds.l	1
stack_buff_i:	
	.ds.l	1


* Stack Section ----------------------- *

	.stack
	.quad

*
* X^bNGA
*
	.ds.b	1024*8
def_stack:

prog_end:
	.end


* EOF --------------------------------- *
